<template>
  <div div="user">
    <b-jumbotron>
      <template slot="header">Available order lists and criteria</template>

      <div>
        <b-alert :show="hasError" dismissible variant="danger">{{ alertMessage }}</b-alert>
      </div>
      <div class="mydiv-tablealign">
        <table class="table table-bordered" style="float: left">
          <thead>
            <tr>
              <th>
                Order lists
                <router-link to="/new_order">
                  <b-button variant="link">[create new]</b-button>
                </router-link>
              </th>
            </tr>
          </thead>
          <tr v-for="order in orders" class="static" v-bind:key="order">
            <td @click="dispatchToOrder(order)">{{order}}</td>
          </tr>
        </table>

        <table class="table table-bordered" style="float: left">
          <thead>
            <tr>
              <th>
                Criteria
                <router-link to="/new_criterion">
                  <b-button variant="link">[create new]</b-button>
                </router-link>
              </th>
            </tr>
          </thead>
          <tr v-for="criterion in criteria" class="static" v-bind:key="criterion">
            <td @click="dispatchToCriterion(criterion)">{{criterion}}</td>
          </tr>
        </table>
      </div>
    </b-jumbotron>
  </div>
</template>

<script>
import { AXIOS } from "./http-common";

export default {
  name: "OrderLists",
  data() {
    return {
      orders: [],
      criteria: [],
      alertMessage: "Request error",
      hasError: false
    };
  },
  created() {
    this.loadCriteria();
    this.loadOrders();
  },
  beforeRouteUpdate(_, __, next) {
    this.loadCriteria();
    this.loadOrders();
    next();
  },
  methods: {
    loadOrders() {
      AXIOS.get(`/edu/orders`, {})
        .then(
          response => {
            console.log(response);
            this.orders = response.data;
            this.hasError = false;
          },
          error => {
            console.log(error);
            this.$data.alertMessage =
              error.response.data.length < 150
                ? error.response.data
                : "Request error. Please, report this error website owners";
            this.hasError = true;
            this.orders = [];
          }
        )
        .catch(e => {
          console.log(e);
          this.showAlert(
            "Server error. Please, report this error website owners"
          );
          this.orders = [];
          this.hasError = true;
        });
    },
    loadCriteria() {
      AXIOS.get(`/edu/criteria`, {})
        .then(
          response => {
            console.log(response);
            this.criteria = response.data;
            this.hasError = false;
          },
          error => {
            console.log(error);
            this.$data.alertMessage =
              error.response.data.length < 150
                ? error.response.data
                : "Request error. Please, report this error website owners";
            this.hasError = true;
            this.criteria = [];
          }
        )
        .catch(e => {
          console.log(e);
          this.showAlert(
            "Server error. Please, report this error website owners"
          );
          this.criteria = [];
          this.hasError = true;
        });
    },
    showAlert() {
      this.dismissCountDown = this.dismissSecs;
    },
    dispatchToOrder(name) {
      this.$router.push({ name: "Order", params: { orderName: name } });
    },
    dispatchToCriterion(name) {
      this.$router.push({ name: "Criterion", params: { criterionName: name } });
    }
  }
};
</script>

<style>
.mydiv-tablealign {
  text-align: center;
}
</style>